###############################################################################################
# $Id: wait_client.py,v 1.8 2004/04/01 09:30:45 chakie Exp $
###############################################################################################

import pygame
from pygame.locals import *
import scenario
import properties
import traceback
import sys
import string
import widget
from net.connection  import Connection
from select          import select
from button          import Button
from title_label     import TitleLabel
from normal_label    import NormalLabel
from image           import Image
from widget_manager  import WidgetManager
from dialog          import *
from messagebox      import Messagebox
from scenario_parser import ScenarioParser
from messagebox      import Messagebox

class WaitClient(Dialog):
    """
    This class is used as a dialog for showing 
    """

    def __init__ (self):
        "Creates the dialog."

        # init superclass
        Dialog.__init__ (self, scenario.sdl)

        # set our background to a tiled image
        self.setBackground ( properties.window_background )

        # we want timer events
        self.enableTimer ( 200 )
        

    def createWidgets (self):
        "Creates all widgets for the dialog."

        # create a message
        message = "Waiting for other player to connect..."
 
        # the status label
        self.wm.register ( NormalLabel ( message, (340, 213) ) )

        # create the cancel button
        self.wm.register ( Button ( properties.path_dialogs + "butt-cancel-moff.png",
                                    properties.path_dialogs + "butt-cancel-mover.png",
                                    (406, 650), {widget.MOUSEBUTTONUP : self.cancel } ) )



    def timer (self):
        """Callback triggered when the dialog has enabled timers and a timer fires. First tries to
        read the configuration from the connection, and if that succeeds further calls will read the
        raw scenario data. If all succeeds the dialog is accepted."""

        try:
            # get data about the scenario from the server, block until we get it
            scenario_line = scenario.connection.readLine ( -1 )

            # get data about the opponent from the server, block until we get it
            player_line = scenario.connection.readLine ( -1 )

        except:
            # failed to get data?
            Messagebox ( "Error getting data from server!" )

            # we're cancelling the dialog
            return self.reject ()

        print "WaitClient.timer: got '%s'" % scenario_line
        print "WaitClient.timer: got '%s'" % player_line
        
        # we're done with the dialog
        return self.accept ()


    def cancel (self, trigger, event):
        """Callback triggered when the user clicks the 'Cancel' button. Simply closes the dialog and
        returns to the main dialog, ignoring any changes."""

        # we're cancelling the dialog
        return self.reject ()



#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
