###############################################################################################
# $Id: factory.py,v 1.1 2004/01/14 07:11:09 chakie Exp $
###############################################################################################

# import all updates
from chat             import Chat 
from cease_fire       import CeaseFire
from progress         import Progress
from quit             import Quit
from surrender        import Surrender

# our map of creators
creators = { 'chat'            : Chat,
             'ceasefire'       : CeaseFire,
             'progress'        : Progress,
             'quit'            : Quit,
             'surrender'       : Surrender
             }
             

def create (parameters):
    """Creates a new immediate update from the passed parameters. The parameter is a list of strings
    string that is supposed to be data for a update. The first word is the type of update, and the other
    are data for that specific upate. Based on the type a new instance is created and returned. """  

    # get the packet type
    type = parameters[0]

    # do we have such a plan?
    if not creators.has_key ( type ):
        # not an immediate plan
        return None
    
    # create a update based on the type
    update = creators [type] ()    

    # and let it extract whatever it needs from the parameters it got
    update.extract ( parameters[1:] )

    return update
    
       
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
