###############################################################################################
# $Id: gametime.py,v 1.1 2004/01/14 07:11:09 chakie Exp $
###############################################################################################

import scenario
import properties

class GameTime:
    """
    This class defines the current time in the game, such as the current time in hours, minutes and
    seconds. This data is mainly for viewing use.
    """

    def __init__ (self, hour = 0, minute = 0, second = 0):
        """Creates the instance of the class. Sets default values for all members. If the parameter
        'turn' is set then the timer will start up with a default turn."""

        # set passed/default hour, minute and second
        self.hour   = hour
        self.minute = minute
        self.second = second


    def setTime (self, hour, minute, second):
        """Sets a new current time."""
        self.hour   = hour
        self.minute = minute
        self.second = second


    def getTime (self):
        """Returns the current time of the game. This is a tuple (hour,minute) and is provided for
        convenience. """
        return ( self.getHour(), self.getMinute(), self.getSecond() )

    
    def getHour (self):
        """Returns the current hour of the time."""
        return self.hour + self.getMinute() / 60


    def getMinute (self):
        """Returns the current minute of the time."""
        return self.minute + ( properties.seconds_per_step * self.step ) / 60


    def getSecond (self):
        """Returns the current second of the time."""
        return ( properties.seconds_per_step * self.step ) % 60


#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
