###############################################################################################
# $Id: progress.py,v 1.1 2004/01/14 07:11:09 chakie Exp $
###############################################################################################

import string
import scenario
from action      import Action


class ProgressAct (Action):
    """
    This class implements the immediate update 'progress'. It is used when the server performs
    action calculation to send out progress updates so that the player know what is going on. The
    data in this update is simply a number that indicates the current percentage of calculated
    action. 
    """
    

    def __init__ (self, percentage=0):
        """Initializes the instance."""
        # call superclass constructor
        Immediate.__init__ (self, "progress" )

        # store the percentage
        self.percentage = percentage
        

    def extract (self, parameters):
        """Extracts the data for the command. The only data is the turn when the chat should take place."""
        # parse out the data
        self.percentage = int ( parameters[0] ) 


    def execute (self):
        """Executes the immediate update. Does nothing."""
        pass


    def getPercentage (self):
        """Returns the percentage of the action that has been calculated as a number."""
        return self.percentage
    
        
    def toString (self):
        """Returns a string representation of the command, suitable for sending over a socket."""
        # create a string and return
        return "%s %d\n" % ( self.getName (), self.percentage )


    def __str__ (self):
        """Convenience wrapper for toString() suitable for using when debugging and printing the
        command to the screen. Will just call toString()."""
        return self.toString ()
    
     
#  Local Variables:
#  mode: auto-fill
#  fill-column: 100
#  End:
